#!/bin/bash

BASE_DIR="/var/tmp/opsi-linux-client-agent"
SCRIPT_DIR="postinst.d"
TMP_DIR="/tmp"
LOG_DIR="/var/log/"
LOG_FILE="$LOG_DIR/postinst.log"

systemctl disable olca-install.service

mkdir -p "$TMP_DIR/postinst.d" "$LOG_DIR"
echo "postinst.sh starting" > "$LOG_FILE"

echo "Trying to load .env file" >> "$LOG_FILE"
source $BASE_DIR/files/postinst.d/postinst.env

echo "Copying script files from $BASE_DIR/files/$SCRIPT_DIR to $TMP_DIR/postinst.d" >> "$LOG_FILE"
for file in $BASE_DIR/files/$SCRIPT_DIR/*.sh; do cp "$file" "$TMP_DIR/postinst.d";done >> "$LOG_FILE"

echo "sorting scripts" >> "$LOG_FILE"
ls -1 "$TMP_DIR"/postinst.d/*.sh | sort > "$TMP_DIR/postinst.scripts"
echo "Listing available postinst scripts:" >> "$LOG_FILE"
cat "$TMP_DIR/postinst.scripts" >> "$LOG_FILE"

echo "Executing postinst scripts:" >> "$LOG_FILE"
for script in $(cat $TMP_DIR/postinst.scripts); do
        echo "Executing $script" >> "$LOG_FILE"
        [[ $script == *.sh ]] && ( . "$script") >> "$LOG_FILE" 2>&1
done

echo "Cleaning up:" >> "$LOG_FILE"
#rm -r "$TMP_DIR/postinst.d/"
#rm "$TMP_DIR/postinst.scripts"

echo "Sending log:" >> "$LOG_FILE"

#TODO: sending log to server

shutdown -r

